(
	
	local theObjs=#()
	local lightValues=#()
	local theString=""

	/*This part has the code to parse the scene for whatever we find of interest, in this case, geometric objects without a vray shader attached*/
	for o in geometry where (classof o != targetObject) and (not (matchpattern ((classof o.material) as string) pattern:"VRay*")) do append theObjs o
	for l in lights where (classof l == VrayLight ) and (l.on == on) do
	(
		append lightValues #(l.name, l.multiplier,l.color,l.transform)
	)
	/*IF it found any, then it will proceed with adding the key in the metadata string*/
	if theObjs.count != 0 do
	(
		/*Creating the string with the key name, and ancillary characters, as an array is what will be appended*/
		theString="CUSTOM_materialLessNodeList=("
		/*Adding object names to the array*/
		for o in theObjs do 
			(
				theString+=o.name+","
			)
		theString=substring theString 1 (theString.count-1)
		/*Completing the string*/
		theString+=");"
	)
	
	if lightValues.count != 0 do
	(
		for l in lightValues do
		(
			/*Key name as the light name*/
			theString+="CUSTOM_LT_"+l[1]+"=("
			/*add the multiplier, and the color*/
			theString+=l[2] as string + ",("+ ((l[3].r as float)/255.) as string + ","+((l[3].g as float)/255.) as string + ","+((l[3].r as float)/255.) as string + "),"
			/*add the transforms as pos.x,y,z,rot.z,y,z, scl.x,y,z*/
			theString+="(" + ( formattedPrint (l[4].pos.x) format:"12.8f") + "," + ( formattedPrint (l[4].pos.y) format:"12.8f") + "," + ( formattedPrint (l[4].pos.z) format:"12.8f")+ "," + l[4].rotation.x as string + "," + l[4].rotation.y as string + "," + l[4].rotation.z as string + "," + l[4].scale.x as string + "," + l[4].scale.y as string + "," + l[4].scale.z as string + ")" 
			/*Completing the string*/
			theString+=");"
		)
	)

	/*RE work: if the VRayOptionRE element is there, use it, if not, add it, and then fill the metadata string with the one just generated*/
	reM=maxOps.GetRenderElementMgr #Production
	theOptionRE=el=undefined
	for n=0 to (reM.numrenderelements() -1 )do
	(
		el=(reM.getrenderelement n)
		if (matchpattern el.elementname pattern:"VRayOptionRE" ) do
		exit with theOptionRE = el
	)
	if theOptionRE != undefined then
	(
		wasOpen=renderSceneDialog.isopen()
		el.exr_metadata=""
		el.exr_metadata=theString
		if wasOpen do
		(
			renderSceneDialog.close()
			renderscenedialog.commit()
			renderSceneDialog.open()
		)
		
	)
	else
	(
		el=(VRayOptionRE) ekementname:"VRayOptionRE"
		el.exr_metadata=theString
		reM.addrenderelement el
		wasOpen=renderSceneDialog.isopen()
		if wasOpen do
		(
			renderSceneDialog.close()
			renderscenedialog.commit()
			renderSceneDialog.open()
		)
	)
)

